/***************************************************************************
*   Copyright (C) 2008 by Jonathan Schmidt-Dominé                         *
*   the-user@gradespro.com                                                *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
***************************************************************************/

/*
Hier kann man sich einmal ein Beispiel für die Verwendung von dynh_ptr und controlled_dynh_ptr ansehen.
*/

#include "dynh_ptr.h"
#include <iostream>

using namespace std;

struct foo
{
    int bar;
};

int main()
{
    foo x, y, z;
    x.bar = -04711;
    y.bar = 815;
    z.bar = 1337;
    dynh_ptr<foo> p1(x);
    controlled_dynh_ptr<foo> p2;
    dynh_ptr<foo> p3(p2);
    cout << (p3.points_at(p2) ? "funzt" : "funzt net") << endl << (p2.points_at(p1) ? "funzt net" : "funzt") << endl;
    p1 = y;
    try
    {
        p2 = p3;
    }
    catch(domain_error& e)
    {
        cerr << e.what() << endl;
        cout << "hi" << endl;
    }
    cout << p1->bar << " " << p2->bar << " " << p3->bar << endl;
    return 0;
}
