/***************************************************************************
*   Copyright (C) 2008 by Jonathan Schmidt-Dominé                         *
*   the-user@gradespro.com                                                *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
***************************************************************************/

/*
Dieser Zeiger lässt sich mit der Funktion unbind gezielt löschen, der Destruktor ruft ebenfalls den Löschvorgang auf.
*/

#ifndef MASTER_PTR_H
#define MASTER_PTR_H

#include "ptr_interface.h"
#include "PTR_ACCESS.h"
#include <stdexcept>
using namespace std;

template<typename type> class master_ptr : public ptr_interface<type>
{
    protected:
        type** ptr;
        type*& get_ptr();
    public:
        master_ptr();
        master_ptr(type*);
        virtual ~master_ptr();
        PTR_ACCESS master_ptr<type>& operator=(ptr_interface<type>&);
        PTR_ACCESS master_ptr<type>& operator=(type*);
        PTR_ACCESS type& operator*() const;
        PTR_ACCESS type* operator->() const;
        PTR_ACCESS void unbind();
        PTR_ACCESS bool points_at(type&) const;
        PTR_ACCESS bool points_at(ptr_interface<type>&) const;
};

#ifndef V_PTR
    #include "master_ptr.cpp"
#endif

#endif
