/***************************************************************************
*   Copyright (C) 2008 by Jonathan Schmidt-Dominé                         *
*   the-user@gradespro.com                                                *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
***************************************************************************/

/*
Hier kann man sich Beispiele für die Verwendung von jpointer, master_ptr und slave_ptr anschauen.
*/
#include "jpointer.h"
#include "master_ptr.h"
#include "slave_ptr.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int test()
{
    master_ptr<int> mp1 (new int(4711));
    master_ptr<int> mp2 = new int(815);
    cout << *mp1 << endl;
    mp1.unbind();
    try
    {
        *mp1;
    }
    catch(domain_error e)
    {
        cerr << e.what() << endl;
    }
    slave_ptr<int> sp1 (mp1);
    try
    {
        cout << *sp1 << endl;
    }
    catch(domain_error e)
    {
        cerr << e.what() << endl;
    }
    jpointer<int> p1 (new int(12));
    jpointer<int> p2;
    try
    {
        *p2;
    }
    catch(domain_error e)
    {
        cerr << e.what() << endl;
        cerr << "bla" << endl;
        p1.unbind();
    }
    int* i1 = new int(13);
    jpointer<int> p3(i1);
    if(p3.points_at(*i1))
        cout << "gut" << endl;
    return 0;
}

int main()
{
    test();
    return 0;
}
