/***************************************************************************
*   Copyright (C) 2008 by Jonathan Schmidt-Dominé                         *
*   the-user@gradespro.com                                                *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
***************************************************************************/

/*
Eine abstrakte Basisklasse, um das Interface eines Zeigers festzulegen
*/

#ifndef PTR_INTERFACE_H

#define PTR_INTERFACE_H

#include "PTR_ACCESS.h"

#include <iostream>
using namespace std;

template<typename type> class jpointer;
template<typename type> class dynh_ptr;
template<typename type> class master_ptr;
template<typename type> class slave_ptr;

template<typename type> class ptr_interface
{
    private:
        virtual type*& get_ptr() = 0;
    public:
        typedef type ptr_type;
        virtual ptr_interface<type>& operator=(ptr_interface<type>& optr) = 0;
        virtual ptr_interface<type>& operator=(type* optr) = 0;
        virtual type& operator*() const = 0;
        virtual type* operator->() const = 0;
        virtual bool points_at(ptr_interface<type>&) const = 0;
        virtual bool points_at(type &) const = 0;
        virtual void unbind() = 0;
        friend class jpointer<type>;
        friend class dynh_ptr<type>;
        friend class slave_ptr<type>;
        friend class master_ptr<type>;
};

#endif
